From 888246ccc522a551551d47370e70f01f1d4c65ea Mon Sep 17 00:00:00 2001
From: Amul Sul <amul.sul@enterprisedb.com>
Date: Wed, 14 Dec 2022 11:19:56 +0530
Subject: [PATCH v1 18/25] Change pg_mcv_list_in to allow non-throw error
 reporting

---
 src/backend/statistics/mcv.c              |  2 +-
 src/test/regress/expected/type_sanity.out | 12 ++++++++++++
 src/test/regress/sql/type_sanity.sql      |  3 +++
 3 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/src/backend/statistics/mcv.c b/src/backend/statistics/mcv.c
index f5a7c312728..e1d53a50ee9 100644
--- a/src/backend/statistics/mcv.c
+++ b/src/backend/statistics/mcv.c
@@ -1479,7 +1479,7 @@ pg_mcv_list_in(PG_FUNCTION_ARGS)
 	 * pg_mcv_list stores the data in binary form and parsing text input is
 	 * not needed, so disallow this.
 	 */
-	ereport(ERROR,
+	ereturn(fcinfo->context, (Datum) 0,
 			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 			 errmsg("cannot accept a value of type %s", "pg_mcv_list")));
 
diff --git a/src/test/regress/expected/type_sanity.out b/src/test/regress/expected/type_sanity.out
index 241b628fb07..7ea63338d99 100644
--- a/src/test/regress/expected/type_sanity.out
+++ b/src/test/regress/expected/type_sanity.out
@@ -856,3 +856,15 @@ SELECT pg_input_error_message('1 99999', 'int2vector');
  value "99999" is out of range for type smallint
 (1 row)
 
+SELECT pg_input_is_valid('1', 'pg_mcv_list');
+ pg_input_is_valid 
+-------------------
+ f
+(1 row)
+
+SELECT pg_input_error_message('1', 'pg_mcv_list');
+          pg_input_error_message           
+-------------------------------------------
+ cannot accept a value of type pg_mcv_list
+(1 row)
+
diff --git a/src/test/regress/sql/type_sanity.sql b/src/test/regress/sql/type_sanity.sql
index b59ebf9490c..15bcd0aa761 100644
--- a/src/test/regress/sql/type_sanity.sql
+++ b/src/test/regress/sql/type_sanity.sql
@@ -610,3 +610,6 @@ SELECT pg_input_is_valid('1 XYZ', 'int2vector');
 SELECT pg_input_error_message('1 XYZ', 'int2vector');
 SELECT pg_input_is_valid('1 99999', 'int2vector');
 SELECT pg_input_error_message('1 99999', 'int2vector');
+
+SELECT pg_input_is_valid('1', 'pg_mcv_list');
+SELECT pg_input_error_message('1', 'pg_mcv_list');
-- 
2.18.0

